"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _visitorMark = _interopRequireDefault(require("./visitor-mark"));

var _visitorRemoval = _interopRequireDefault(require("./visitor-removal"));

var _visitorRemovalDecl = _interopRequireDefault(require("./visitor-removal-decl"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const DEFAULT_ITERATIONS = 5;

function _default({
  types: t
}, {
  iterations = null
} = {}) {
  const iterationsToRun = parseInt(iterations, 10) || DEFAULT_ITERATIONS;
  return {
    visitor: {
      Program: {
        exit(path) {
          for (let i = 0; i < iterationsToRun; i++) {
            // Mark the relevant variables
            path.traverse(_visitorMark.default, {
              t
            });
            path.traverse(_visitorRemoval.default, {
              t
            });
            path.traverse(_visitorRemovalDecl.default, {
              t
            });
          }
        }

      }
    }
  };
}