"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _common = require("./common");

var _default = {
  Identifier(path, {
    t
  }) {
    const parentPath = path.parentPath;

    if (t.isMemberExpression(parentPath)) {
      return;
    }

    const statementParent = (0, _common.getParentFunctionOrStatement)(path);

    if (t.isImportDeclaration(statementParent)) {
      // Handle recursive destructuring here
      if (t.isImportDefaultSpecifier(parentPath)) {// - mark as tracked
      }

      return;
    }

    if (t.isExpressionStatement(statementParent)) {
      const expressionPath = statementParent.get('expression');

      if (t.isCallExpression(expressionPath)) {// - mark as used
      } else if (t.isAssignmentExpression(expressionPath)) {
        const sideAse = (0, _common.getSideInAssignmentExpression)(path, expressionPath);

        if (sideAse === 'left') {
          if (!(0, _common.isNodeBindingUsed)(path)) {
            if (t.isAssignmentExpression(expressionPath.node.right)) {
              expressionPath.replaceWith(expressionPath.node.right);
            } else {
              expressionPath.remove();
            }
          }
        }
      }

      return;
    }

    if (t.isVariableDeclaration(statementParent)) {
      const sideDecl = (0, _common.getSideInDeclaration)(path, statementParent);

      if (sideDecl === 'left') {
        if (t.isObjectProperty(parentPath)) {
          const parentObjPropPath = parentPath;
          const objPropSide = (0, _common.getSideInObjectProperty)(path, parentObjPropPath);

          if (objPropSide === 'right') {// is a decl
            // - mark as tracked
          }
        }
      } // Ignore right here, remove the entire statement if left is unused


      return;
    }

    if (t.isFunction(statementParent)) {
      // Identifier is a parameter or in function body
      if (t.isFunction(parentPath)) {// We have a simple param identifier
        // - mark as tracked
      } else if (t.isObjectProperty(parentPath)) {
        const objPropSide = (0, _common.getSideInObjectProperty)(path, parentPath);

        if (objPropSide === 'right') {// - mark as tracked
        }
      } else if (t.isAssignmentExpression(parentPath)) {
        const sideAse = (0, _common.getSideInAssignmentExpression)(path, parentPath);

        if (sideAse === 'right') {// - mark as tracked
        } else if (sideAse === 'left') {
          if (!(0, _common.isNodeBindingUsed)(path)) {
            if (t.isAssignmentExpression(parentPath.parentPath) || t.isAssignmentExpression(parentPath.node.right)) {
              parentPath.replaceWith(parentPath.node.right);
            } else {
              parentPath.remove();
            }
          }
        }
      }

      return;
    }
  }

};
exports.default = _default;